package org.simantics.scl.compiler.internal.types.ast;

import org.simantics.scl.compiler.internal.types.TypeElaborationContext;
import org.simantics.scl.compiler.types.Type;
import org.simantics.scl.compiler.types.Types;
import org.simantics.scl.compiler.types.exceptions.SCLTypeParseException;



public class TListAst extends TypeAst {
    public final TypeAst component;
    
    public TListAst(TypeAst component) {
        this.component = component;
    }

    @Override
    public void toString(StringBuilder b) {
        b.append('[');
        component.toString(b);
        b.append(']');
    }

    @Override
    public Type toType(TypeElaborationContext context) throws SCLTypeParseException {
        return Types.list(component.toType(context));
    }

    @Override
    public int getPrecedence() {
        return 0;
    }
}
